import sys
import os
import random

class myDict:
    def __init__(self):
        self.readme = {}
        self.readme['append'] = '''
            >>> import random_Json_generator as rj
            >>> md = rj.myDict()
            >>> x = {1:11,2:22,3:33}
            >>> md.myDict_Append(x,'ok')
            >>> x
            {1: 11, 2: 22, 3: 33, 4: 'ok'}
            >>> 
            '''
        self.readme['pop'] = '''
            >>> import random_Json_generator as rj
            >>> md = rj.myDict()
            >>> x = {1:11,2:22,3:33}
            >>> md.myDict_Pop(x,2)      
            22
            >>> x
            {1: 11, 2: 33}
            >>> 
            '''
    def __dir__(self):
        return(['myDict_Append','myDict_Pop'])
    def myDict_Append(self,myDict,value):
        last_Seq = myDict.__len__()
        new_Seq = last_Seq + 1
        myDict[new_Seq] = value
    def myDict_Pop(self,myDict,index):
        last_Seq = myDict.__len__()
        be_Poped = myDict[index]
        for i in range(index,last_Seq):
            myDict[i] = myDict[i+1]
        del myDict[last_Seq]
        return(be_Poped)

class funcs(myDict):
    def __init__(self):
        #visible string between chr(32) and chr(127) except "(",")","[","]","{","}"#
        self.choice_String =' !"#$%&\'*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ\\^_`abcdefghijklmnopqrstuvwxyz|~'
        self.readme = {}
        self.readme['rand.string'] = '''
            #generate a random string from the chars in self.choice_String#
            #the length of the string less than max_Word_Length or equals max_Word_Length#
            <rand.string(max_Word_Length)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()                    
            >>> f.choice_String
            ' !"#$%&\'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~'
            >>> f.rand.string(f.choice_String,10) 
            'FFWvQd.U!{'
            >>> f.rand.string(f.choice_String,10)
            'zF5Z2|PC'
            >>> f.rand.string(f.choice_String,10)
            '7Gm'
            >>> f.rand.string(f.choice_String,10)
            'Z>*'
            >>> f.rand.string(f.choice_String,10)
            '(Y'
            >>> 
            '''
        self.readme['rand.DL'] = '''
            #generate a empty dict or empty list#
            #the paras ratio_D and ratio_L determines the "chances"#
            <rand.DL(ratio_D,ratio_L,user_Defined={})>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> f.rand.DL(2,1)
            []
            >>> f.rand.DL(2,1)
            []
            >>> f.rand.DL(2,1)
            []
            >>> f.rand.DL(2,1)
            {}
            >>> f.rand.DL(2,1)
            {}
            >>> f.rand.DL(2,1)
            {}
            >>> f.rand.DL(2,1)
            []
            >>> 
            '''
        self.readme['rand.max_LVs'] = '''
            #generate a max_LVs between min_Range and max_Range#
            #which means the possible max layers of the Json data structure#
            #layers means how many times the "nested" happened#
            #for exzample: [1,2,3] layer 1 Json#
            #              [{1:'a'},2,[3,4,5]] layer 2 Json#
            #              [{1:'a'},2,[3,{'x':None,'y':None},5]] layer 3 Json#
            <rand.max_LVs(min_Range,max_Range)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> f.rand.max_LVs(5,8)
            6
            >>> f.rand.max_LVs(5,8)
            7
            >>> f.rand.max_LVs(5,8)
            6
            >>> f.rand.max_LVs(5,8)
            7
            >>> f.rand.max_LVs(5,8)
            7
            >>> f.rand.max_LVs(5,8)
            6
            >>> f.rand.max_LVs(5,8)
            8
            >>> f.rand.max_LVs(5,8)
            5
            >>> f.rand.max_LVs(5,8)
            7
            >>> 
            '''
        self.readme['rand.size'] = '''
            #generate a size between min_Range and max_Range#
            #which means the size of a dict or list ready to be created#
            <rand.size(min_Range,max_Range)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> f.rand.size(5,8)
            5
            >>> f.rand.size(5,8)
            8
            >>> f.rand.size(5,8)
            5
            >>> f.rand.size(5,8)
            7
            >>> f.rand.size(5,8)
            5
            >>> f.rand.size(5,8)
            6
            >>> 
            '''
        self.readme['rand.prefix'] = '''
            #generate a dict, the keys from 1 to size#
            #the values are in the  format: (prefix + '_' + int + '_' + random string )#
            #this is used to generate keys with different length#
            <rand.prefix(prefix,size)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> f.rand.prefix('key',8)
            {1: 'key_8_', 2: "key_5_#Mhg'>", 3: 'key_9_T4', 4: 'key_2_Pu', 5: 'key_7_So>~"B', 6: 'key_6_v', 7: 'key_4_$=$B6', 8: 'key_3_mgI='}
            >>> f.rand.prefix('key',8)
            {1: 'key_5_guUV:%)GpI', 2: 'key_4_2Cb_T', 3: 'key_9_\\`', 4: 'key_2_[IOWrwC', 5: "key_6_:>'nsCrF", 6: 'key_3_%yLA4Ge]cM', 7: 'key_8_6?Zaznz', 8: 'key_7_tzk@N-t-k'}
            >>> f.rand.prefix('key',8)
            {1: 'key_8_', 2: "key_7_Y%9c':jL9~", 3: 'key_4_T!^4', 4: 'key_5_', 5: 'key_2_^/\\A+.]N', 6: 'key_3_`Fr^8', 7: 'key_9_/HrxN', 8: 'key_6_`lOOyR!'}
            >>> 
            '''
        self.readme['rand.type'] = '''
            #generate a type (V or D or L)#
            #the paras ratio_V and ratio_D and ratio_L determines the "chances"#
            #type V means neigher list nor dict#
            #type D means dict#
            #type L means list#
            <rand.type(ratio_V,ratio_D,ratio_L)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> f.rand.type(1,1,1)                
            'L'
            >>> f.rand.type(1,1,1)
            'V'
            >>> f.rand.type(1,1,1)
            'V'
            >>> f.rand.type(1,1,1)
            'V'
            >>> f.rand.type(1,1,1)
            'D'
            >>> f.rand.type(1,1,1)
            'D'
            >>> f.rand.type(1,1,1)
            'L'
            >>> 
            '''
        self.readme['rand.value'] = '''
            #generate a random string in the below format ('value' + '_' + number)#
            #the number is a random between (and include) 1 and max_Seq#
            # T = 'V' or 'D' or 'L'#
            #type V means neigher list nor dict#
            #type D means dict#
            #type L means list#
            <rand.value(T,max_Seq)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> f.rand.value('V',8)
            'value_6'
            >>> f.rand.value('V',8)
            'value_1'
            >>> f.rand.value('V',8)
            'value_8'
            >>> f.rand.value('L',8)
            []
            >>> f.rand.value('L',8)
            []
            >>> f.rand.value('D',8)
            {}
            >>> 
            '''
        self.rand = self.rand_Ops(self.random_String,self.random_DL,self.random_Max_LVs,self.random_Size,self.random_Prefix,self.random_Type,self.random_Value)
        self.readme['fillin.one'] = '''
            #randomly fill in a empty list or empty dict#
            #if DL is a empty list,the element will be  "a empty list []"  or  "a empty dict {}" or a random string#
            #if DL is a empty dict,the element will be  "randomkey:[]"  or  "randomkey:{}" or  randomkey:(random string)#
            #the total numbers of elements is less than or equal to max_Size whose default value  is 20#
            <fillin.one(DL,max_Size=20)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> empty_L = []
            empty_L
            >>> f.fillin.one(empty_L)
            >>> empty_L
            ['value_2', 'value_1']
            >>> empty_L = []
            >>> f.fillin.one(empty_L)
            >>> empty_L
            [[], 'value_5', [], 'value_5', {}]
            >>> empty_L = []
            >>> f.fillin.one(empty_L)
            >>> empty_L
            ['value_8', 'value_4', {}, 'value_2', 'value_8', 'value_13', [], 'value_9', 'value_5', 'value_3', {}, 'value_14', 'value_12', 'value_4', {}]
            >>> empty_D = []
            >>> f.fillin.one(empty_D)
            >>> empty_D
            [[], 'value_4', [], 'value_2', 'value_5']
            >>> empty_D = []
            >>> f.fillin.one(empty_D)
            >>> empty_D
            ['value_6', {}, {}, 'value_8', 'value_1', 'value_2', 'value_5', 'value_4']
            >>> empty_D = []
            >>> f.fillin.one(empty_D)
            empty_D>>> empty_D
            ['value_8', {}, 'value_4', 'value_7', 'value_3', 'value_6', 'value_8', {}]
            >>> 
            
            '''
        self.readme['fillin.all'] = '''
            #randomly fill in all empty lists or empty dicts  ,ptrs to whom stored in a dict#
            #each list or dict is filled in by fillin.one#
            <fillin.all(ptr_To_Empty_DL_Dict)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> empty_1 = {}
            >>> empty_2 = []
            >>> empty_3 = []
            >>> empty_4 = {} 
            >>> empty_D = { 1:empty_1,2:empty_2,3:empty_3,4:empty_4 }
            >>> empty_D
            {1: {}, 2: [], 3: [], 4: {}}
            >>> f.fillin.all(empty_D)
            empty_4
            empty_D>>> empty_1
            {'key_9_Q': 'value_11', 'key_13_]y': {}, 'key_4_8KD': 'value_13', 'key_3_h;G': 'value_4', 'key_7_]e': 'value_11', 'key_11_*O': [], 'key_14_0': [], 'key_2_yZHrhlw)<': 'value_12', 'key_8_%U@i=f+': [], 'key_12_1bEe]Fs': [], 'key_10_z5T': 'value_2', 'key_5_<': 'value_12', 'key_6_pB>': 'value_10'}
            >>> empty_2
            ['value_1', 'value_2', 'value_4', 'value_2']
            >>> empty_3
            ['value_7', [], 'value_10', 'value_9', 'value_10', 'value_5', 'value_1', [], 'value_1', 'value_4', []]
            >>> empty_4
            {'key_3_ez>)nDbV': 'value_6', 'key_6_ws:3()(': 'value_12', 'key_4_: `*mk': {}, 'key_11_$/]GdAJqF@': 'value_3', 'key_8_B-2^Y}8W': {}, 'key_9_6_FpZ': 'value_11', 'key_5_h8Y]Qc@;Y-': {}, 'key_2_|U,_N!Z': 'value_5', 'key_10_g': [], 'key_13_': {}, 'key_7_': {}, 'key_12_:~uE@': 'value_12'}
            >>> empty_D
            {1: {'key_9_Q': 'value_11', 'key_13_]y': {}, 'key_4_8KD': 'value_13', 'key_3_h;G': 'value_4', 'key_7_]e': 'value_11', 'key_11_*O': [], 'key_14_0': [], 'key_2_yZHrhlw)<': 'value_12', 'key_8_%U@i=f+': [], 'key_12_1bEe]Fs': [], 'key_10_z5T': 'value_2', 'key_5_<': 'value_12', 'key_6_pB>': 'value_10'}, 2: ['value_1', 'value_2', 'value_4', 'value_2'], 3: ['value_7', [], 'value_10', 'value_9', 'value_10', 'value_5', 'value_1', [], 'value_1', 'value_4', []], 4: {'key_3_ez>)nDbV': 'value_6', 'key_6_ws:3()(': 'value_12', 'key_4_: `*mk': {}, 'key_11_$/]GdAJqF@': 'value_3', 'key_8_B-2^Y}8W': {}, 'key_9_6_FpZ': 'value_11', 'key_5_h8Y]Qc@;Y-': {}, 'key_2_|U,_N!Z': 'value_5', 'key_10_g': [], 'key_13_': {}, 'key_7_': {}, 'key_12_:~uE@': 'value_12'}}
            >>> 
            '''
        self.fillin = self.fillin_Ops(self.random_Fillin_Empty_DL,self.random_Fillin_All_Empty_DL)
        self.readme['ptr.emptyDL'] = '''
            #search a json data structure ,find all the empty lists or dicts #
            #the fillin mechanism will gurantee that all the emprt lists or dicts only exsit in the current layer(the currently bottom layer)#
            <ptr.emptyDL(last_Already_Filled_Ptr_To_Empty_DL_Dict)>
            >>> import random_Json_generator as rj
            >>> f = rj.funcs()
            >>> empty_D = {
            ...     1: {
            ...         'key_9_Q': 'value_11',
            ...         'key_13_]y': {},
            ...         'key_4_8KD': 'value_13',
            ...         'key_3_h;G': 'value_4',
            ...         'key_7_]e': 'value_11',
            ...         'key_11_*O': [],
            ...         'key_14_0': [],
            ...         'key_2_yZHrhlw)<': 'value_12',
            ...         'key_8_%U@i=f+': [],
            ...         'key_12_1bEe]Fs': [],
            ...         'key_10_z5T': 'value_2',
            ...         'key_5_<': 'value_12',
            ...         'key_6_pB>': 'value_10'
            ...     },
            ...     2: ['value_1', 'value_2', 'value_4', 'value_2'],
            ...     3: ['value_7', [], 'value_10', 'value_9', 'value_10', 'value_5', 'value_1', [], 'value_1', 'value_4', [], 'value_10', {}, 'value_11'],
            ...     4: {
            ...         'key_3_ez>)nDbV': 'value_6',
            ...         'key_6_ws:3()(': 'value_12',
            ...         'key_4_: `*mk': {},
            ...         'key_11_$/]GdAJqF@': 'value_3',
            ...         'key_8_B-2^Y}8W': {},
            ...         'key_9_6_FpZ': 'value_11',
            ...         'key_5_h8Y]Qc@;Y-': {},
            ...         'key_2_|U,_N!Z': 'value_5',
            ...         'key_10_g': [],
            ...         'key_13_': {},
            ...         'key_7_': {},
            ...         'key_12_:~uE@': 'value_12'
            ...     }
            ... }
            >>> f.ptr.emptyDL(empty_D)
            {1: {}, 2: [], 3: [], 4: [], 5: [], 6: [], 7: [], 8: [], 9: {}, 10: {}, 11: {}, 12: {}, 13: {}, 14: {}, 15: []}
            >>> 
            '''
        self.ptr = self.ptr_Ops(self.get_Ptr_To_Empty_DL_Dict)
        self.readme['creat_Random_Json'] = '''
            #generate a random json data #
            #the para total_LVs means the depth#
            <creat_Random_Json(self,total_LVs)>
            >>> import random_Json_generator as rj
            >>> import jsbeautifier as jb
            >>> f = rj.funcs()
            >>> J = f.creat_Random_Json(3)
            >>> print(jb.beautify(str(J)))
            ['value_14', 'value_12', {}, {}, {}, 'value_6', 'value_3', 'value_19', 'value_11', 'value_11', 'value_9', 'value_6', 'value_3', [], 'value_3', 'value_1', 'value_8', 'value_8', []]
            >>> J = f.creat_Random_Json(4)
            >>> print(jb.beautify(str(J)))
            ['value_2', 'value_4', ['value_13', [],
                [],
                [], 'value_10', 'value_4', 'value_7', [], 'value_3', 'value_7', 'value_9', 'value_9', 'value_11'
            ], 'value_3', ['value_12', 'value_12', 'value_12', [], {},
                [], 'value_8', 'value_11', 'value_5', 'value_9', 'value_3', 'value_3', 'value_8', [],
                []
            ], 'value_1', 'value_1', {
                'key_3_f': [],
                'key_4_8o KNWj>_': 'value_5',
                'key_11_!~Uwf': 'value_10',
                'key_10_5': {},
                'key_12_Ovg-': {},
                'key_8_.nBn-D> uv': 'value_1',
                'key_9_Q^': {},
                'key_13_>~5--k.v': 'value_12',
                'key_2_&iS`A?': 'value_10',
                'key_7_,Ug;SCC`?': 'value_9',
                'key_5_>F0ueu': {},
                'key_6_XS;qh': 'value_1'
            }]
            >>> 
            '''
    def __dir__(self):
        return(['readme','choice_String','rand','ptr','creat_Random_Json'])
    def random_String(self,choice_String,max_Word_Length):
        length = random.randrange(max_Word_Length+1)
        temp_String = ''
        for i in range(0,length):
            temp_String = ''.join((temp_String,random.choice(choice_String)))
        return(temp_String)
    def random_DL(self,ratio_D,ratio_L,user_Defined={}):
        if((ratio_D == 0)&(ratio_L == 0)):
            return(user_Defined)
        elif(ratio_D == 0):
            return([])
        elif(ratio_L == 0):
            return({})
        else:
            rand_Num = random.randrange(1,3)
            if(rand_Num == 1):
                return({})
            else:
                return([])
    def random_Max_LVs(self,min_Range,max_Range):
        rand_Max_LVs = random.randrange(min_Range,max_Range+1)
        return(rand_Max_LVs)
    def random_Size(self,min_Range,max_Range):
        rand_Size = random.randrange(min_Range,max_Range+1)
        return(rand_Size)
    def random_Prefix(self,prefix,size):
        p_Dict = {}
        for i in range(1,size+1):
            p_Dict[i] = i
        new_P_Dict = {}
        new_Seq = 1
        while(p_Dict.__len__()>0):
            rand_Num = random.randrange(1,p_Dict.__len__()+1)
            ele = self.myDict_Pop(p_Dict,rand_Num)
            ele = ''.join((prefix,'_',str(ele+1),'_',self.random_String(self.choice_String,10)))
            new_P_Dict[new_Seq] = ele
            new_Seq = new_Seq + 1
        return(new_P_Dict)
    def random_Type(self,ratio_V,ratio_D,ratio_L):
        total = ratio_V + ratio_D + ratio_L 
        boundary_V = ratio_V+1
        boundary_D = ratio_V+ratio_D+1
        rand_Num = random.randrange(1,total+1)
        if(rand_Num in range(1,boundary_V)):
            return('V')
        elif(rand_Num in range(boundary_V,boundary_D)):
            return('D')
        else:
            return('L')
    def random_Value(self,T,max_Seq):
        if(T=='D'):
            return({})
        elif(T=='L'):
            return([])
        else:
            rand_Seq = random.randrange(1,max_Seq+1)
            value = ''.join(('value','_',str(rand_Seq)))
            return(value)
    class rand_Ops:
        def __init__(self,random_String,random_DL,random_Max_LVs,random_Size,random_Prefix,random_Type,random_Value):
            self.string = random_String
            self.DL = random_DL
            self.max_LVs = random_Max_LVs
            self.size = random_Size
            self.prefix = random_Prefix
            self.type = random_Type
            self.value = random_Value
    def random_Fillin_Empty_DL(self,DL,max_Size=20):
        size = self.rand.size(1,max_Size)
        if(type(DL) == type([])):
            for i in range(0,size):
                T = self.rand.type(5,1,1)
                V = self.rand.value(T,size)
                DL.append(V)
        else:
            keys = self.rand.prefix('key',size)
            for i in range(0,size):
                T = self.rand.type(5,1,1)
                V = self.rand.value(T,size)
                DL[keys[i+1]] = V
    def random_Fillin_All_Empty_DL(self,ptr_To_Empty_DL_Dict):
        ptr_To_Empty_DL_Dict_Len = ptr_To_Empty_DL_Dict.__len__()
        for i in range(1,ptr_To_Empty_DL_Dict_Len+1):
            DL = ptr_To_Empty_DL_Dict[i]
            self.random_Fillin_Empty_DL(DL)
    class fillin_Ops:
        def __init__(self,random_Fillin_Empty_DL,random_Fillin_All_Empty_DL):
            self.one = random_Fillin_Empty_DL
            self.all = random_Fillin_All_Empty_DL
    def get_Ptr_To_Empty_DL_Dict(self,last_Already_Filled_Ptr_To_Empty_DL_Dict):
        curr_Ptr_To_Empty_DL_Dict = {}
        seq = 1
        last_Already_Filled_Ptr_To_Empty_DL_Dict_Len = last_Already_Filled_Ptr_To_Empty_DL_Dict.__len__()
        for i in range(1,last_Already_Filled_Ptr_To_Empty_DL_Dict_Len+1):
            temp = last_Already_Filled_Ptr_To_Empty_DL_Dict[i]
            if(type(temp) == type([])):
                for each in temp:
                    if(type(each)==type([])):
                        curr_Ptr_To_Empty_DL_Dict[seq] = each
                        seq = seq + 1
                    elif(type(each)==type({})):
                        curr_Ptr_To_Empty_DL_Dict[seq] = each
                        seq = seq + 1
                    else:
                        pass
            elif(type(temp) == type({})):
                for each in temp:
                    if(type(temp[each])==type([])):
                        curr_Ptr_To_Empty_DL_Dict[seq] = temp[each]
                        seq = seq + 1
                    elif(type(temp[each])==type({})):
                        curr_Ptr_To_Empty_DL_Dict[seq] = temp[each]
                        seq = seq + 1
                    else:
                        pass
            else:
                pass
        return(curr_Ptr_To_Empty_DL_Dict)
    class ptr_Ops:
        def __init__(self,get_Ptr_To_Empty_DL_Dict):
            self.emptyDL = get_Ptr_To_Empty_DL_Dict
    def creat_Random_Json(self,total_LVs):
        lv = 1
        J = self.rand.DL(1,1)
        curr_Ptr_To_Empty_DL_Dict = {1:J} 
        self.fillin.all(curr_Ptr_To_Empty_DL_Dict)
        last_Already_Filled_Ptr_To_Empty_DL_Dict = curr_Ptr_To_Empty_DL_Dict
        lv = lv + 1
        curr_Ptr_To_Empty_DL_Dict = self.ptr.emptyDL(last_Already_Filled_Ptr_To_Empty_DL_Dict)
        while((curr_Ptr_To_Empty_DL_Dict.__len__()>0)&(lv < total_LVs - 1)):
            self.fillin.all(curr_Ptr_To_Empty_DL_Dict)
            last_Already_Filled_Ptr_To_Empty_DL_Dict = curr_Ptr_To_Empty_DL_Dict
            lv = lv + 1
            curr_Ptr_To_Empty_DL_Dict = self.ptr.emptyDL(last_Already_Filled_Ptr_To_Empty_DL_Dict)
        return(J)



